from typing import Iterable

from tic.shared.dto import Dto
from tic.reputation.shared.enums.reputation_category import ReputationCategory
from tic.reputation.shared.enums.reputation_tags import ReputationTags


class Candidate(Dto):
    decode_settings = {
        "category": lambda x: None if x is None else ReputationCategory(x),
        "additional_tags": lambda x: list()
        if x is None
        else [ReputationTags(y) for y in x],
    }
    encode_settings = {
        "category": lambda x: None if x is None else x.value,
        "additional_tags": lambda x: None
        if x is None or len(x) == 0
        else [y.value for y in x],
    }

    def __init__(
        self,
        category: ReputationCategory = None,
        additional_tags: Iterable[ReputationTags] = None,
    ):
        self.category = category
        self.additional_tags = (
            additional_tags if additional_tags is not None else list()
        )
